package starterCode;


/***************************************************
 Starter code for CS182
 Assignment 3: Backpropagation
 Unit.java
 **************************************************/

import java.util.*;


/**
 * Unit is the basic unit of a neural network.
 */
public class Unit {
	
	public NetParams params;

	// Unit attributes

	// The following Unit attributes are suggested starting points
	// for the assignment. You may wish to modify them as necessary
	// for your particular implementation.

	/** input Units for this Unit */
	public Vector<Unit> in;

	/** output Units for this Unit */
	public Vector<Unit> out;

	/**
	 * Current (input) weights for this Unit. I.e. inWeights[1] is the weight
	 * from the in[1] unit. The last element should be the bias weight.
	 */
	public double[] inWeights;

	/** This unit's activation level */
	public double activation;

	/** This unit's error. */
	public double error;

	/** This unit's delta. */
	public double delta;

	/** Stochastic weight changes, for each weight. */
	public double[] weightChange;

	/** Here we accumulate weight changes during batch processing. */
	public double[] weightChangeAccumulator;

	/** The weight change */
	public double[] weightChangeMomentum;

	/**
	 * Constructor for Unit class. Takes an index number and Net to which Unit
	 * belongs.
	 * 
	 */
	public Unit(NetParams params) {
		this.params = params;
		in = new Vector<Unit>();
		out = new Vector<Unit>();
	}

	/** Keep track of incoming units. */
	public void addIncomingUnit(Unit inUnit) {
		this.in.add(inUnit);
	}

	/** Keep track of outgoing units. */
	public void addOutgoingUnit(Unit outUnit) {
		this.out.add(outUnit);
	}

	/**
	 * Randomize all incoming weights between the network's minimum
	 * and maximum weights, including bias weights.
	 */
	public void initialize() {
		// TODO implement this!
	}

	/**
	 * computeActivation() Compute output activation of this unit. Apply sigmoid
	 * function to weighted sum of inputs. Store it in this.activation and return
	 * it.
	 */
	public double computeActivation() {
		// TODO implement this!
		return 0;
	}

	/**
	 * Computes error and delta for the output node. (not squared error)
	 * 
	 * @param target
	 *            is the desired value of this node's output
	 */
	public void computeError(int target) {
		// TODO implement this!
	}

	/**
	 * Computes delta contribution to upstream nodes.
	 * 
	 * Be sure to clear upstream deltas before using.
	 * 
	 */
	public void propagateDelta() {
		// TODO implement this!
	}

	/**
	 * Calculate the current weight change based only on the error of the latest
	 * datum, including a momentum factor. May want to use
	 * computeWeightChangeMomentum to calculate the momentum factor.
	 */
	public void computeStochasticWeightChange() {
		// TODO implement this!
	}

	/**
	 * Calculate the current weight change, including a momentum factor, based
	 * on the accumulated weight changes from the past epoch. May want to use
	 * computeWeightChangeMomentum to calculate the momentum factor.
	 */
	public void computeBatchWeightChange() {
		// TODO implement this!
	}

	/**
	 * Calculate the weight change for the current training datum and accumulate
	 * it for batch processing. This should ignore momentum. 
	 */
	public void accumulateWeightChange() {
		// TODO implement this!
	}

	/**
	 * Update stochastic or accumulated changes to weights for this pattern.
	 */
	public void updateWeights() {
		// TODO implement this!
	}

	/**
	 * Reset accumulators that store weight changes for the entire epoch. 
	 *
	 */
	public void resetWeightAccumulators() {
		// TODO implement this!
	}

	/**
	 * Calculate momentum factor for weight change. Store in
	 * this.weightChangeMomentum.
	 */
	public void computeWeightChangeMomentum() {
		// TODO implement this!
	}

	// additional methods?
	// ** to be filled in **

	/**
	 * Return a random number between min and max.
	 */
	Random randy = new Random();

	public double getRandom(double min, double max) {
		return (randy.nextDouble() * (max - min)) + min;
	}
}
